MODULE Windows;

IMPORT
  SYSTEM, Kernel;

CONST
  NULL*                      = 0;
  HWND_TOP*                  = 0;
  HWND_BOTTOM*               = 1;
  HWND_TOPMOST*              = -1;
  HWND_NOTOPMOST*            = -2;

  BS_PUSHBUTTON* = {};
  BS_DEFPUSHBUTTON* = {0};
  BS_CHECKBOX* = {1};
  BS_AUTOCHECKBOX* = {0, 1};
  BS_RADIOBUTTON* = {2};
  BS_3STATE* = {0, 2};
  BS_AUTO3STATE* = {1, 2};
  BS_GROUPBOX* = {0..2};
  BS_USERBUTTON* = {3};
  BS_AUTORADIOBUTTON* = {0, 3};
  BS_OWNERDRAW* = {0, 1, 3};
  BS_LEFTTEXT* = {5};
  BS_TEXT* = {};
  BS_ICON* = {6};
  BS_BITMAP* = {7};
  BS_LEFT* = {8};
  BS_RIGHT* = {9};
  BS_CENTER* = {8, 9};
  BS_TOP* = {10};
  BS_BOTTOM* = {11};
  BS_VCENTER* = {10, 11};
  BS_PUSHLIKE* = {12};
  BS_MULTILINE* = {13};
  BS_NOTIFY* = {14};
  BS_FLAT* = {15};
  BS_RIGHTBUTTON* = {5};

  CTLCOLOR_MSGBOX*           = 0;
  CTLCOLOR_EDIT*             = 1;
  CTLCOLOR_LISTBOX*          = 2;
  CTLCOLOR_BTN*              = 3;
  CTLCOLOR_DLG*              = 4;
  CTLCOLOR_SCROLLBAR*        = 5;
  CTLCOLOR_STATIC*           = 6;
  CTLCOLOR_MAX*              = 7;
  COLOR_SCROLLBAR*           = 0;
  COLOR_BACKGROUND*          = 1;
  COLOR_ACTIVECAPTION*       = 2;
  COLOR_INACTIVECAPTION*     = 3;
  COLOR_MENU*                = 4;
  COLOR_WINDOW*              = 5;
  COLOR_WINDOWFRAME*         = 6;
  COLOR_MENUTEXT*            = 7;
  COLOR_WINDOWTEXT*          = 8;
  COLOR_CAPTIONTEXT*         = 9;
  COLOR_ACTIVEBORDER*        = 10;
  COLOR_INACTIVEBORDER*      = 11;
  COLOR_APPWORKSPACE*        = 12;
  COLOR_HIGHLIGHT*           = 13;
  COLOR_HIGHLIGHTTEXT*       = 14;
  COLOR_BTNFACE*             = 15;
  COLOR_BTNSHADOW*           = 10H;
  COLOR_GRAYTEXT*            = 17;
  COLOR_BTNTEXT*             = 18;
  COLOR_INACTIVECAPTIONTEXT* = 19;
  COLOR_BTNHIGHLIGHT*        = 20;
  COLOR_3DDKSHADOW*          = 21;
  COLOR_3DLIGHT*             = 22;
  COLOR_INFOTEXT*            = 23;
  COLOR_INFOBK*              = 24;
  COLOR_HOTLIGHT*            = 26;
  COLOR_GRADIENTACTIVECAPTION*   = 27;
  COLOR_GRADIENTINACTIVECAPTION* = 28;
  COLOR_MENUHILIGHT*         = 29;
  COLOR_MENUBAR*             = 30;
  COLOR_ENDCOLORS*           = COLOR_MENUBAR;
  COLOR_DESKTOP*             = COLOR_BACKGROUND;
  COLOR_3DFACE*              = COLOR_BTNFACE;
  COLOR_3DSHADOW*            = COLOR_BTNSHADOW;
  COLOR_3DHIGHLIGHT*         = COLOR_BTNHIGHLIGHT;
  COLOR_3DHILIGHT*           = COLOR_BTNHIGHLIGHT;
  COLOR_BTNHILIGHT*          = COLOR_BTNHIGHLIGHT;

  CS_VREDRAW* = {0};
  CS_HREDRAW* = {1};
  CS_KEYCVTWINDOW* = {2};
  CS_DBLCLKS* = {3};
  CS_OWNDC* = {5};
  CS_CLASSDC* = {6};
  CS_PARENTDC* = {7};
  CS_NOKEYCVT* = {8};
  CS_NOCLOSE* = {9};
  CS_SAVEBITS* = {11};
  CS_BYTEALIGNCLIENT* = {12};
  CS_BYTEALIGNWINDOW* = {13};
  CS_GLOBALCLASS* = {14};
  CS_IME* = {16};

  ES_LEFT* = {};
  ES_CENTER* = {0};
  ES_RIGHT* = {1};
  ES_MULTILINE* = {2};
  ES_UPPERCASE* = {3};
  ES_LOWERCASE* = {4};
  ES_PASSWORD* = {5};
  ES_AUTOVSCROLL* = {6};
  ES_AUTOHSCROLL* = {7};
  ES_NOHIDESEL* = {8};
  ES_OEMCONVERT* = {10};
  ES_READONLY* = {11};
  ES_WANTRETURN* = {12};
  ES_NUMBER* = {13};

  GWL_WNDPROC*               = -4 (* {2..31} *);
  GWL_HINSTANCE*             = -6 (* {1, 3..31} *);
  GWL_HWNDPARENT*            = -8 (* {3..31} *);
  GWL_STYLE*                 = -16 (* {4..31} *);
  GWL_EXSTYLE*               = -20 (* {2, 3, 5..31} *);
  GWL_USERDATA*              = -21 (* {0, 1, 3, 5..31} *);
  GWL_ID*                    = -12 (* {2, 4..31} *);

  HTCAPTION*               = 2;

  IDI_APPLICATION*         = 1X;

  IDC_ARROW*               = 32512;
  IDC_IBEAM*               = 32513;
  IDC_WAIT*                = 32514;
  IDC_CROSS*               = 32515;
  IDC_UPARROW*             = 32516;
  IDC_SIZE*                = 32640;
  IDC_ICON*                = 32641;
  IDC_SIZENWSE*            = 32642;
  IDC_SIZENESW*            = 32643;
  IDC_SIZEWE*              = 32644;
  IDC_SIZENS*              = 32645;
  IDC_SIZEALL*             = 32646;
  IDC_NO*                  = 32648;
  IDC_HAND*                = 32649;
  IDC_APPSTARTING*         = 32650;
  IDC_HELP*                = 32651;

  MB_OK* = {};
  MB_ICONEXCLAMATION* = {4, 5};
  HWNDDesktop* = 0;

  SW_HIDE*             = 0;
  SW_SHOWNORMAL*       = 1;
  SW_NORMAL*           = 1;
  SW_SHOWMINIMIZED*    = 2;
  SW_SHOWMAXIMIZED*    = 3;
  SW_MAXIMIZE*         = 3;
  SW_SHOWNOACTIVATE*   = 4;
  SW_SHOW*             = 5;
  SW_MINIMIZE*         = 6;
  SW_SHOWMINNOACTIVE*  = 7;
  SW_SHOWNA*           = 8;
  SW_RESTORE*          = 9;
  SW_SHOWDEFAULT*      = 10;
  SW_MAX*              = 10;

  SWP_SHOWWINDOW*      = {6};
  SWP_HIDEWINDOW*      = {7};

  WS_OVERLAPPED* = {};
  WS_POPUP* = {31};
  WS_CHILD* = {30};
  WS_MINIMIZE* = {29};
  WS_VISIBLE* = {28};
  WS_DISABLED* = {27};
  WS_CLIPSIBLINGS* = {26};
  WS_CLIPCHILDREN* = {25};
  WS_MAXIMIZE* = {24};
  WS_CAPTION* = {22, 23};
  WS_BORDER* = {23};
  WS_DLGFRAME* = {22};
  WS_VSCROLL* = {21};
  WS_HSCROLL* = {20};
  WS_SYSMENU* = {19};
  WS_THICKFRAME* = {18};
  WS_GROUP* = {17};
  WS_TABSTOP* = {16};
  WS_MINIMIZEBOX* = {17};
  WS_MAXIMIZEBOX* = {16};
  WS_TILED* = {};
  WS_ICONIC* = {29};
  WS_SIZEBOX* = {18};
  WS_TILEDWINDOW* = {16..19, 22, 23};
  WS_OVERLAPPEDWINDOW* = {16..19, 22, 23};
  WS_POPUPWINDOW* = {19, 23, 31};
  WS_CHILDWINDOW* = {30};

  WS_EX_DLGMODALFRAME* = {0};
  WS_EX_NOPARENTNOTIFY* = {2};
  WS_EX_TOPMOST* = {3};
  WS_EX_ACCEPTFILES* = {4};
  WS_EX_TRANSPARENT* = {5};
  WS_EX_MDICHILD* = {6};
  WS_EX_TOOLWINDOW* = {7};
  WS_EX_WINDOWEDGE* = {8};
  WS_EX_CLIENTEDGE* = {9};
  WS_EX_CONTEXTHELP* = {10};
  WS_EX_RIGHT* = {12};
  WS_EX_LEFT* = {};
  WS_EX_RTLREADING* = {13};
  WS_EX_LTRREADING* = {};
  WS_EX_LEFTSCROLLBAR* = {14};
  WS_EX_RIGHTSCROLLBAR* = {};
  WS_EX_CONTROLPARENT* = {16};
  WS_EX_STATICEDGE* = {17};
  WS_EX_APPWINDOW* = {18};
  WS_EX_OVERLAPPEDWINDOW* = {8, 9};
  WS_EX_PALETTEWINDOW* = {3, 7, 8};

  PFD_TYPE_RGBA* = 0X (* {} *);
  PFD_TYPE_COLORINDEX* = 1 (* {0} *);
  PFD_MAIN_PLANE* = 0X (* {} *);
  PFD_OVERLAY_PLANE* = 1 (* {0} *);
  PFD_UNDERLAY_PLANE* = -1 (* {0..31} *);
  PFD_DOUBLEBUFFER* = {0};
	PFD_STEREO* = {1};
	PFD_DRAW_TO_WINDOW* = {2};
	PFD_DRAW_TO_BITMAP* = {3};
	PFD_SUPPORT_GDI* = {4};
	PFD_SUPPORT_OPENGL* = {5};
	PFD_GENERIC_FORMAT* = {6};
	PFD_NEED_PALETTE* = {7};
	PFD_NEED_SYSTEM_PALETTE* = {8};
	PFD_SWAP_EXCHANGE* = {9};
	PFD_SWAP_COPY* = {10};
	PFD_SWAP_LAYER_BUFFERS* = {11};
	PFD_DOUBLEBUFFER_DONTCARE* = {30};
  PFD_STEREO_DONTCARE* = {31};

TYPE
  BOOL*               = LONGINT;
  ADDRESS*            = LONGINT;
  ATOM*               = INTEGER;
  HANDLE*             = ADDRESS;
  HMODULE*            = ADDRESS;
  HINSTANCE*          = ADDRESS;
  HGLOBAL*            = HANDLE;
  LPSTR*              = ADDRESS;
  HWND*               = HANDLE;

  HGLRC*              = HANDLE;

  COLORREF*           = LONGINT;
  HDC*                = HANDLE;
  HGDIObj*            = HANDLE;
  HFont*              = HGDIObj;
  HBrush*             = HGDIObj;
  HRgn*               = HGDIObj;
  HBitmap*            = HGDIObj;

  HIcon*              = HANDLE;
  HCursor*            = HANDLE;
  HMenu*              = HANDLE;
  HPalette*           = HANDLE;
  HAccel*             = HANDLE;
  HHook*              = HANDLE;

  Point* = RECORD
    x*, y*: LONGINT
  END;

  Msg* = RECORD [NOTAG]
    hwnd*   : HWND;
    message*: LONGINT;
    wParam*, lParam*: LONGINT;
    time*   : LONGINT;
    point*  : Point;
  END;

  WParam*   = LONGINT;
  LParam*   = LONGINT;
  LResult*  = LONGINT;

  WndProc*    = PROCEDURE [WINAPI] (hwnd: HWND; uMsg: LONGINT; wParam: WParam; lParam: LParam): LResult;

  WndClassEx* = RECORD [NOTAG]
    cbSize*       : LONGINT;
    style*        : SET;
    lpfnWndProc*  : WndProc;
    cbClsExtra*   : LONGINT;
    cbWndExtra*   : LONGINT;
    hInstance*    : HINSTANCE;
    hIcon*        : HIcon;
    hCursor*      : HCursor;
    hbrBackground*: HBrush;
    lpszMenuName* : LPSTR;
    lpszClassName*: LPSTR;
    hIconSm*      : HIcon;
  END;

  TRect* = RECORD [NOTAG]
    left*         : LONGINT;
    top*          : LONGINT;
    right*        : LONGINT;
    bottom*       : LONGINT;
  END;

  TPaintStruct* = RECORD [NOTAG]
    hdc*          : HDC;
    fErase*       : BOOL;
    rcPaint*      : TRect;
    fRestore*     : BOOL;
    fIncUpdate*   : BOOL;
    rgbReserved*  : ARRAY [NOTAG] 32 OF CHAR;
  END;

  PIXELFORMATDESCRIPTOR* = RECORD [NOTAG]
	nSize*: INTEGER;
	nVersion*: INTEGER;
	dwFlags*: SET;
	iPixelType*: CHAR;
	cColorBits*: CHAR;
	cRedBits*: CHAR;
	cRedShift*: CHAR;
	cGreenBits*: CHAR;
	cGreenShift*: CHAR;
	cBlueBits*: CHAR;
	cBlueShift*: CHAR;
	cAlphaBits*: CHAR;
	cAlphaShift*: CHAR;
	cAccumBits*: CHAR;
	cAccumRedBits*: CHAR;
	cAccumGreenBits*: CHAR;
	cAccumBlueBits*: CHAR;
	cAccumAlphaBits*: CHAR;
	cDepthBits*: CHAR;
	cStencilBits*: CHAR;
	cAuxBuffers*: CHAR;
	iLayerType*: CHAR;
	bReserved*: CHAR;
	dwLayerMask*: SET;
	dwVisibleMask*: SET;
	dwDamageMask*: SET;
  END;

VAR
  AllocConsole-     : PROCEDURE [WINAPI] (): BOOL;
  GetStdHandle-     : PROCEDURE [WINAPI] (nStdHandle: LONGINT): HANDLE;
  WriteFile-        : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToWrite: LONGINT; VAR lpNumberOfBytesWritten: LONGINT; lpOverlapped: SYSTEM.PTR): BOOL;
  ReadFile-         : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToRead: LONGINT; VAR lpNumberOfBytesRead: LONGINT; lpOverlapped: SYSTEM.PTR): BOOL;
  ExitProcess-      : PROCEDURE [WINAPI] (uExitCode: LONGINT);

  (* USER32.*)
  PostQuitMessage-  : PROCEDURE [WINAPI] (nExitCode: LONGINT);
  LoadIcon-         : PROCEDURE [WINAPI] (hInstance: HINSTANCE; lpIconName: ARRAY [NOTAG] OF CHAR):HIcon;
  LoadCursor-       : PROCEDURE [WINAPI] (hInstance: HINSTANCE; lpCursorName: LPSTR): HCursor;
  CreateWindowEx-   : PROCEDURE [WINAPI] (dwExStyle: SET; lpClassName, lpWindowName: ARRAY [NOTAG] OF CHAR; dwStyle: SET; x, y, nWidth, nHeight: LONGINT; hWndParent: HWND; hMenu: HMenu; hInstance: HINSTANCE; lpParam: LONGINT): HWND;
  CreateWindow-     : PROCEDURE [WINAPI] (lpClassName,lpWindowName: ARRAY [NOTAG] OF CHAR;dwStyle: SET; X, Y, nWidth, nHeight: LONGINT; hWndParent: HWND;hMenu: HMenu; hInstance: HINSTANCE; lpParam: LONGINT): HWND;
  ShowWindow-       : PROCEDURE [WINAPI] (hWnd: HWND; nCmdShow: LONGINT): BOOL;
  UnregisterClass-  : PROCEDURE [WINAPI] (lpClassName: ARRAY [NOTAG] OF CHAR; hInstance: HINSTANCE): BOOL;
  RegisterClassEx-  : PROCEDURE [WINAPI] (VAR lpwcx: WndClassEx): ATOM;
  GetMessage-       : PROCEDURE [WINAPI] (VAR lpMsg: Msg; hWnd: HWND; wMsgFilterMin, wMsgFilterMax: LONGINT): LONGINT;
  TranslateMessage- : PROCEDURE [WINAPI] (VAR lpMsg: Msg): BOOL;
  DispatchMessage-  : PROCEDURE [WINAPI] (VAR lpMsg: Msg): LONGINT;
  DefWindowProc-    : WndProc;
  UpdateWindow-     : PROCEDURE [WINAPI] (hWnd: HWND): BOOL;
  GetWindowRect-    : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpRect: TRect): BOOL;
  BeginPaint-       : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpPaint: TPaintStruct): HDC;
  EndPaint-         : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpPaint: TPaintStruct): BOOL;
  GetSysColor-      : PROCEDURE [WINAPI] (nIndex: LONGINT): LONGINT;
  GetFocus-         : PROCEDURE [WINAPI] (): LONGINT;
  SendMessage-      : PROCEDURE [WINAPI] (hWnd: HWND; msg, wParam, lParam: LONGINT): LONGINT;
  SetWindowLong-    : PROCEDURE [WINAPI] (hWnd: HWND; nIndex: LONGINT; dwNewLong: SET): LONGINT;
  GetWindowLong-    : PROCEDURE [WINAPI] (hWnd: HWND; nIndex: LONGINT): SET;
  GetDesktopWindow- : PROCEDURE [WINAPI] (): HWND;
  SetWindowPos-     : PROCEDURE [WINAPI] (hWnd: HWND; hWndInsertAfter: HWND;X: LONGINT; Y: LONGINT; cx: LONGINT; cy: LONGINT; uFlags: SET): BOOL;
  MessageBox-       : PROCEDURE [WINAPI] (hwnd: HWND; text, caption: ARRAY [NOTAG] OF CHAR; type: SET): LONGINT;
  GetDC-            : PROCEDURE [WINAPI] (hWnd: HWND): HDC;
  GetAsyncKeyState- : PROCEDURE [WINAPI] (vKey: LONGINT): SHORTINT;
  PeekMessage-      : PROCEDURE [WINAPI] (VAR lpMsg: Msg; hWnd: HWND; wMsgFilterMin, wMsgFilterMax, wRemoveMsg: LONGINT): BOOLEAN;

  (* GDI2.DLL *)
  CreateFont-       : PROCEDURE [WINAPI] (p0:  LONGINT; p1:  LONGINT; p2:  LONGINT; p3: LONGINT;
                                          p4:  LONGINT; p5:  LONGINT; p6:  LONGINT; p7: LONGINT; p8: LONGINT; p9: LONGINT;
                                          p10: LONGINT; p11: LONGINT; p12: LONGINT; p13: LPSTR): HFont;
  DeleteObject-     : PROCEDURE [WINAPI] (p0: HGDIObj): BOOL;
  SetBkMode-        : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT): LONGINT;
  SelectObject-     : PROCEDURE [WINAPI] (p0: HDC; p1: HGDIObj): HGDIObj;
  CreateSolidBrush- : PROCEDURE [WINAPI] (p0: COLORREF): HBrush;
  ChoosePixelFormat-: PROCEDURE [WINAPI] (p0: HDC; p1: PIXELFORMATDESCRIPTOR): LONGINT;
  SetPixelFormat-   : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; VAR p2: PIXELFORMATDESCRIPTOR): BOOL;
  SwapBuffers-      : PROCEDURE [WINAPI] (DC: HDC): BOOL;
  LineTo-           : PROCEDURE [WINAPI] (DC: HDC; X, Y: LONGINT): BOOL;

  (*Opengl32.DLL*)
  wglCreateContext- : PROCEDURE [WINAPI] (DC: HDC): HGLRC;
  wglMakeCurrent-   : PROCEDURE [WINAPI] (DC: HDC; p2: HGLRC): BOOL;

  hInstance*        : HINSTANCE;

PROCEDURE Shutdown*(code: LONGINT);
BEGIN
  Kernel.Shutdown(code);
END Shutdown;

BEGIN
  hInstance := Kernel.GetModuleHandle(NIL);
  IF Kernel.call = 0 THEN
    INC(Kernel.call);
    Kernel.Init();
  ELSIF Kernel.ExitProc # NIL THEN
    Kernel.Shutdown(0);
  END;
END Windows.
  










  
